VERSION = "0.01"
AUTHOR = "martblek (martblek@gmail.com)"

vb = renoise.ViewBuilder()
vbs = vb.views
dialog = nil
rns = nil
rnt = renoise.tool()
ra = renoise.app()

BUFFERS = {"84", "168", "337", "674", "1348", "2697", "5395", "10790"}
SAMPLES = tonumber(BUFFERS[1])
HARMONIC_SERIES = {}
HARMONY_OFFSET = 1
BASE_WAVEFORM = {}
USER_WAVEFORM = {}

for i=1, 256 do
  HARMONIC_SERIES[i] = 0
end
HARMONIC_SERIES[1] = 1 

require "src/generators"
require "src/gui"

renoise.tool():add_menu_entry{
  name = "Sample Editor: Harmoniks",
  invoke = function()
    prepare_for_start()
  end
}

renoise.tool():add_keybinding{
  name="Global:Tools: Harmoniks",
  invoke=function()
    prepare_for_start()
  end
}

_AUTO_RELOAD_DEBUG = function()
end


--[[--------------------------------------------------------------------------------
TOOLS
]]----------------------------------------------------------------------------------

function int(number)
  local f = math.floor(number)
  if (number == f) or (number % 2.0 == 0.5) then
    return f
  else
    return math.floor(number + 0.5)
  end
end



function draw_sample()

  local instrument = renoise.song().selected_instrument
  local selected_sample = renoise.song().selected_sample_index
  local samples_nr = table.getn(instrument.samples)

  instrument.name="Harmoniks Instrument"

  local new_sample
  if samples_nr == 0 then
    new_sample = instrument:insert_sample_at(1)
  else
    new_sample = renoise.song().selected_sample
  end

  new_sample.loop_mode = 2

  local new_buffer = new_sample.sample_buffer
  new_buffer:create_sample_data(44100, 32, 1, SAMPLES)

  new_buffer:prepare_sample_data_changes()
  for i=1, #BASE_WAVEFORM do
    local r = wave_calc(i)
    new_buffer:set_sample_data(1, i, r)
    USER_WAVEFORM[i] = r
    --print(USER_WAVEFORM[i], BASE_WAVEFORM[i])
  end


  new_buffer:finalize_sample_data_changes()

end